#pragma once

#include "codec_gen.hh"
#include "params.hh"

class Base_Type;
class TTCN_Typedescriptor_t;
class TTCN_Buffer;

namespace LibHttp__XmlMessageBodyTypes {
  class XmlBody;
}

class held_codec: public codec_gen <LibHttp__XmlMessageBodyTypes::XmlBody, LibHttp__XmlMessageBodyTypes::XmlBody>
{
public:
  explicit held_codec() : codec_gen<LibHttp__XmlMessageBodyTypes::XmlBody, LibHttp__XmlMessageBodyTypes::XmlBody>() { };
  virtual ~held_codec() { };

  virtual int encode (const LibHttp__XmlMessageBodyTypes::XmlBody& body, OCTETSTRING& data);
  virtual int decode (const OCTETSTRING& p_data, LibHttp__XmlMessageBodyTypes::XmlBody& body, params* p_params = NULL);

}; // End of class held_codec
